diff --git a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 18da082d4..01ee41827 100644
--- a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -7,8 +7,8 @@ import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ImageParser;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
@@ -19,6 +19,9 @@ import net.minecraft.core.world.World;
 
 public abstract class EntityRenderer<T extends Entity>
 {
+    protected EntityRenderDispatcher renderDispatcher;
+    protected float shadowSize;
+    protected float shadowOpacity;
 
     public EntityRenderer()
     {
@@ -26,24 +29,27 @@ public abstract class EntityRenderer<T extends Entity>
         shadowOpacity = 1.0F;
     }
 
-    public abstract void doRender(Tessellator tessellator, T entity, double x, double y, double z,
-                                  float yaw, float partialTick);
+    public abstract void render(Tessellator tessellator, T entity, double x, double y, double z,
+                                float yaw, float partialTick);
 
-    public void doRenderPreview(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick) {
-        doRender(tessellator, entity, x, y, z, yaw, partialTick);
+    public void renderPreview(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick) {
+        render(tessellator, entity, x, y, z, yaw, partialTick);
     }
 
-    protected void loadTexture(String texturePath)
+    protected void bindTexture(String texturePath)
     {
         RenderEngine renderEngine = renderDispatcher.renderEngine;
-        renderEngine.bindTexture(renderEngine.getTexture(texturePath));
+        renderEngine.bindTexture(renderEngine.loadTexture(texturePath));
+    }
+    public boolean bindDownloadableTexture(String urlTexture, String backupTexture, ImageParser imageParser) {
+        return renderDispatcher.renderEngine.bindDownloadableTexture(urlTexture, backupTexture, imageParser);
     }
     
     private void renderFire(Tessellator tessellator, T entity, double x, double y, double z, float partialTick)
     {
-        GL11.glDisable(2896 /*GL_LIGHTING*/);
+        GL11.glDisable(GL11.GL_LIGHTING);
         IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
-        texture.parentAtlas.bindTexture();
+        texture.parentAtlas.bind();
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
         float f9 = entity.bbWidth * 1.4F;
@@ -87,7 +93,7 @@ public abstract class EntityRenderer<T extends Entity>
         }
         tessellator.draw();
         GL11.glPopMatrix();
-        GL11.glEnable(2896 /*GL_LIGHTING*/);
+        GL11.glEnable(GL11.GL_LIGHTING);
     }
 
     private void renderShadow(Tessellator tessellator, T entity, double posX, double posY, double posZ,
@@ -96,18 +102,18 @@ public abstract class EntityRenderer<T extends Entity>
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         RenderEngine renderengine = renderDispatcher.renderEngine;
-        renderengine.bindTexture(renderengine.getTexture("%clamp%/misc/shadow.png"));
+        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
         World world = getWorld();
         GL11.glDepthMask(false);
         double lerpX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
         double lerpY = entity.yo + (entity.y - entity.yo) * (double)partialTick + (double)entity.getShadowHeightOffs();
         double lerpZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
-        int minX = MathHelper.floor_double(lerpX - (double)shadowSize);
-        int maxX = MathHelper.floor_double(lerpX + (double)shadowSize);
-        int minY = MathHelper.floor_double(lerpY - (double)shadowSize);
-        int maxY = MathHelper.floor_double(lerpY);
-        int minZ = MathHelper.floor_double(lerpZ - (double)shadowSize);
-        int maxZ = MathHelper.floor_double(lerpZ + (double)shadowSize);
+        int minX = MathHelper.floor(lerpX - (double)shadowSize);
+        int maxX = MathHelper.floor(lerpX + (double)shadowSize);
+        int minY = MathHelper.floor(lerpY - (double)shadowSize);
+        int maxY = MathHelper.floor(lerpY);
+        int minZ = MathHelper.floor(lerpZ - (double)shadowSize);
+        int maxZ = MathHelper.floor(lerpZ + (double)shadowSize);
         double dxLerp = posX - lerpX;
         double dyLerp = posY - lerpY;
         double dzLerp = posZ - lerpZ;
@@ -141,16 +147,16 @@ public abstract class EntityRenderer<T extends Entity>
     }
 
     private void renderShadowOnBlock(Tessellator tessellator, T entity, Block block, double d, double d1, double d2,
-                                     int x, int y, int z, float opacity, float size, double d3,
-                                     double d4, double d5)
+                                     int x, int y, int z, float opacity, float size, double xo,
+                                     double yo, double zo)
     {
-        if(!block.renderAsNormalBlock())
+        if(!block.isCubeShaped())
         {
             return;
         }
         double brightness = getWorld().getLightBrightness(x, y, z);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        double alpha = ((double)opacity - (d1 - ((double)(y + 1) + d4)) / 2D) * 0.5D * brightness;
+        double alpha = ((double)opacity - (d1 - ((double)(y + 1) + yo)) / 2D) * 0.5D * brightness;
         if(alpha < 0.0D)
         {
             return;
@@ -162,11 +168,11 @@ public abstract class EntityRenderer<T extends Entity>
         tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float)alpha);
         AABB aabb = block.getCollisionBoundingBoxFromPool(getWorld(), x, y, z);
 
-        double xMin = aabb.minX + d3;
-        double xMax = aabb.maxX + d3;
-        double yMin = aabb.maxY + d4 + 0.015625D - 1;
-        double zMin = aabb.minZ + d5;
-        double zMax = aabb.maxZ + d5;
+        double xMin = aabb.minX + xo;
+        double xMax = aabb.maxX + xo;
+        double yMin = aabb.maxY + yo + 0.015625D - 1;
+        double zMin = aabb.minZ + zo;
+        double zMax = aabb.maxZ + zo;
         float f2 = (float)((d - xMin) / 2D / (double)size + 0.5D);
         float f3 = (float)((d - xMax) / 2D / (double)size + 0.5D);
         float f4 = (float)((d2 - zMin) / 2D / (double)size + 0.5D);
@@ -179,7 +185,7 @@ public abstract class EntityRenderer<T extends Entity>
 
     public static void renderOffsetAABB(Tessellator tessellator, AABB axisalignedbb, double d, double d1, double d2)
     {
-        GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         tessellator.startDrawingQuads();
         tessellator.setTranslation(d, d1, d2);
@@ -215,10 +221,10 @@ public abstract class EntityRenderer<T extends Entity>
         tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.maxZ);
         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
         tessellator.draw();
-        GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
     }
 
-    public static void renderAABB(AABB axisalignedbb)
+    public static void renderFlatAABB(AABB axisalignedbb)
     {
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
@@ -249,7 +255,7 @@ public abstract class EntityRenderer<T extends Entity>
         tessellator.draw();
     }
 
-    public void setRenderDispatcher(EntityRenderDispatcher dispatcher)
+    public void init(EntityRenderDispatcher dispatcher)
     {
         this.renderDispatcher = dispatcher;
     }
@@ -258,8 +264,7 @@ public abstract class EntityRenderer<T extends Entity>
 
     }
 
-    public void doRenderShadowAndFire(Tessellator tessellator, T entity, double x, double y, double z,
-                                      float f, float partialTick)
+    public void postRender(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick)
     {
         if(renderDispatcher.gameSettings != null && (renderDispatcher.gameSettings.fancyGraphics.value == 1 && shadowSize > 0.0F))
         {
@@ -280,12 +285,4 @@ public abstract class EntityRenderer<T extends Entity>
     {
         return renderDispatcher.getFontRenderer();
     }
-    
-    public boolean loadDownloadableTexture(String url, String localTexture, ImageParser imageParser) {
-    	return renderDispatcher.renderEngine.loadDownloadableTexture(url, localTexture, imageParser);
-    }
-
-    protected EntityRenderDispatcher renderDispatcher;
-    protected float shadowSize;
-    protected float shadowOpacity;
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/FallingSandRenderer.java b/src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java
similarity index 52%
rename from src/main/java/net/minecraft/client/render/entity/FallingSandRenderer.java
rename to src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java
index a52429354..2d33d7b7d 100644
--- a/src/main/java/net/minecraft/client/render/entity/FallingSandRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/FallingBlockRenderer.java
@@ -2,39 +2,37 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.EntityFallingSand;
+import net.minecraft.core.entity.FallingBlockEntity;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            Render, RenderBlocks, Block, EntityFallingSand, 
+//            Render, RenderBlocks, Block, FallingBlockEntity,
 //            MathHelper, Entity
 
-public class FallingSandRenderer extends EntityRenderer<EntityFallingSand>
+public class FallingBlockRenderer extends EntityRenderer<FallingBlockEntity>
 {
 
-    public FallingSandRenderer()
+    public FallingBlockRenderer()
     {
         blockRenderer = new RenderBlocks();
         shadowSize = 0.5F;
     }
 
     @Override
-    public void doRender(Tessellator tessellator, EntityFallingSand entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
+    public void render(Tessellator tessellator, FallingBlockEntity fallingBlock, double x, double y, double z, float yaw, float partialTick) {
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
-        TextureRegistry.blockAtlas.bindTexture();
-        Block block = Block.blocksList[entity.blockID];
-        World world = entity.getWorld();
-        GL11.glDisable(2896 /*GL_LIGHTING*/);
-        blockRenderer.renderBlockFallingSand(tessellator, BlockModelDispatcher.getInstance().getDispatch(block), block, world, MathHelper.floor_double(entity.x), MathHelper.floor_double(entity.y), MathHelper.floor_double(entity.z));
-        GL11.glEnable(2896 /*GL_LIGHTING*/);
+        TextureRegistry.blockAtlas.bind();
+        Block block = Block.blocksList[fallingBlock.blockID];
+        World world = fallingBlock.getWorld();
+        GL11.glDisable(GL11.GL_LIGHTING);
+        blockRenderer.renderBlockFallingSand(tessellator, BlockModelDispatcher.getInstance().getDispatch(block), block, world, MathHelper.floor(fallingBlock.x), MathHelper.floor(fallingBlock.y), MathHelper.floor(fallingBlock.z));
+        GL11.glEnable(GL11.GL_LIGHTING);
         GL11.glPopMatrix();
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/FireballRenderer.java b/src/main/java/net/minecraft/client/render/entity/FireballRenderer.java
index 8f306a11f..4161af8a7 100644
--- a/src/main/java/net/minecraft/client/render/entity/FireballRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/FireballRenderer.java
@@ -1,35 +1,33 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.projectile.EntityFireball;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.projectile.FireballProjectile;
+
+import net.minecraft.core.item.Items;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
-// Referenced classes of package net.minecraft.src:
-//            Render, Item, Tessellator, RenderManager,
-//            EntityFireball, Entity
 
-public class FireballRenderer extends EntityRenderer<EntityFireball>
-{
+public class FireballRenderer extends EntityRenderer<FireballProjectile> {
 
     public FireballRenderer()
     {
     }
 
-    public void renderFireball(EntityFireball entity, double d, double d1, double d2,
+    public void renderFireball(FireballProjectile entity, double d, double d1, double d2,
                                float f, float f1)
     {
 
         GL11.glPushMatrix();
         GL11.glTranslatef((float)d, (float)d1, (float)d2);
-        GL11.glDisable(2896 /*GL_LIGHTING*/);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final float scalar = 2.0F;
         GL11.glScalef(scalar, scalar, scalar);
-        IconCoordinate i = ItemModelDispatcher.getInstance().getDispatch(Item.ammoFireball).getIcon(null, Item.ammoFireball.getDefaultStack());
-        i.parentAtlas.bindTexture();
+        IconCoordinate i = ItemModelDispatcher.getInstance().getDispatch(Items.AMMO_FIREBALL).getIcon(null, Items.AMMO_FIREBALL.getDefaultStack());
+        i.parentAtlas.bind();
         Tessellator tessellator = Tessellator.instance;
         float f3 = (float) i.getIconUMin();
         float f4 = (float) i.getIconUMax();
@@ -48,14 +46,14 @@ public class FireballRenderer extends EntityRenderer<EntityFireball>
         tessellator.addVertexWithUV(f7 - f8, 1.0F - f9, 0.0D, f4, f5);
         tessellator.addVertexWithUV(0.0F - f8, 1.0F - f9, 0.0D, f3, f5);
         tessellator.draw();
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glPopMatrix();
-        GL11.glEnable(2896 /*GL_LIGHTING*/);
+        GL11.glEnable(GL11.GL_LIGHTING);
     }
 
     @Override
-    public void doRender(Tessellator tessellator, EntityFireball entity, double x, double y, double z,
-                         float yaw, float partialTick)
+    public void render(Tessellator tessellator, FireballProjectile entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         renderFireball(entity, x, y, z, yaw, partialTick);
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/FireflyRenderer.java b/src/main/java/net/minecraft/client/render/entity/FireflyRenderer.java
index 1e8982f78..36a52ed5e 100644
--- a/src/main/java/net/minecraft/client/render/entity/FireflyRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/FireflyRenderer.java
@@ -2,27 +2,27 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.client.entity.fx.EntityFireflyFX;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.client.entity.particle.FireflyParticle;
 import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
-public class FireflyRenderer extends EntityRenderer<EntityFireflyCluster> {
-	private final List<EntityFireflyFX> fireflies = new ArrayList<>();
+public class FireflyRenderer extends EntityRenderer<FireflyClusterMob> {
+	private final List<FireflyParticle> fireflies = new ArrayList<>();
 	private final Minecraft mc;
 	private final Random rand = new Random(0);
 	private long lastTick;
 
 	public FireflyRenderer() {
 		for (int i = 0; i < 20; i++) {
-			EntityFireflyFX fx = new EntityFireflyFX(null, rand.nextFloat() - 0.5f, rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
+			FireflyParticle fx = new FireflyParticle(null, rand.nextFloat() - 0.5f, rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
 			fx.noPhysics = true;
-			fx.setParticleAge(rand.nextInt(20));
+			fx.setAge(rand.nextInt(20));
 			fireflies.add(fx);
 		}
 		mc = Minecraft.getMinecraft(this);
@@ -30,13 +30,13 @@ public class FireflyRenderer extends EntityRenderer<EntityFireflyCluster> {
 	}
 
 	@Override
-	public void doRender(Tessellator tessellator, EntityFireflyCluster parent, double x, double y, double z, float yaw, float partialTick) {
+	public void render(Tessellator tessellator, FireflyClusterMob parent, double x, double y, double z, float yaw, float partialTick) {
 		// Fireflies are rendered as particles which are spawned in the entity class
 	}
 
 	@Override
-	public void doRenderPreview(Tessellator tessellator, EntityFireflyCluster entity, double x, double y, double z, float yaw, float partialTick) {
-		super.doRenderPreview(tessellator, entity, x, y, z, yaw, partialTick);
+	public void renderPreview(Tessellator tessellator, FireflyClusterMob entity, double x, double y, double z, float yaw, float partialTick) {
+		super.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
 
 		long currentTick = System.currentTimeMillis();
 		int storedTicks = (int) ((currentTick - lastTick) / 50.0f);
@@ -46,15 +46,15 @@ public class FireflyRenderer extends EntityRenderer<EntityFireflyCluster> {
 		GL11.glDisable(GL11.GL_CULL_FACE);
 		GL11.glEnable(GL11.GL_TEXTURE_2D);
 		Lighting.disable();
-		TextureRegistry.particleAtlas.bindTexture();
+		TextureRegistry.particleAtlas.bind();
 		for (int i = 0; i < fireflies.size(); i++) {
-			EntityFireflyFX firefly = fireflies.get(i);
+			FireflyParticle firefly = fireflies.get(i);
 			Tessellator t = Tessellator.instance;
 			t.startDrawingQuads();
-			firefly.renderParticleInGUI(t, partialTick);
+			firefly.renderParticleInGui(t, partialTick);
 			t.draw();
 			for (int j = 0; j < storedTicks; j++) {
-				firefly.tickGUI();
+				firefly.tickGui();
 				lastTick = currentTick;
 			}
 			if (firefly.removed) {
@@ -68,9 +68,9 @@ public class FireflyRenderer extends EntityRenderer<EntityFireflyCluster> {
 		if (fireflies.size() < 20) {
 			for (int i = fireflies.size(); i < 20; i++) {
 				if (rand.nextInt(4) == 0) continue;
-				EntityFireflyFX fx = new EntityFireflyFX(null, rand.nextFloat() - 0.5f, rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
+				FireflyParticle fx = new FireflyParticle(null, rand.nextFloat() - 0.5f, rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
 				fx.noPhysics = true;
-				fx.setParticleAge(rand.nextInt(20));
+				fx.setAge(rand.nextInt(20));
 				fireflies.add(fx);
 			}
 		}
diff --git a/src/main/java/net/minecraft/client/render/entity/FishingBobberRenderer.java b/src/main/java/net/minecraft/client/render/entity/FishingBobberRenderer.java
new file mode 100644
index 000000000..08b23d203
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/entity/FishingBobberRenderer.java
@@ -0,0 +1,61 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.FishingBobberEntity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import org.lwjgl.opengl.GL11;
+public class FishingBobberRenderer extends SpriteRenderer<FishingBobberEntity>
+{
+
+    public FishingBobberRenderer() {
+        super(TextureRegistry.getTexture("minecraft:particle/bobber"));
+    }
+
+    @Override
+    public void render(Tessellator tessellator, FishingBobberEntity entity, double x, double y, double z, float yaw, float partialTick) {
+        super.render(tessellator, entity, x, y, z, yaw, partialTick);
+        if(entity.owner != null)
+        {
+            float f11 = entity.owner.getSwingProgress(partialTick);
+            float f12 = MathHelper.sin(MathHelper.sqrt_float(f11) * MathHelper.PI);
+            Vec3 vec3 = Vec3.getTempVec3(-0.5D, 0.03D, 0.8D);
+            vec3.rotateAroundX((-(entity.owner.xRotO + (entity.owner.xRot - entity.owner.xRotO) * partialTick) * MathHelper.PI) / 180F);
+            vec3.rotateAroundY((-(entity.owner.yRotO + (entity.owner.yRot - entity.owner.yRotO) * partialTick) * MathHelper.PI) / 180F);
+            vec3.rotateAroundY(f12 * 0.5F);
+            vec3.rotateAroundX(-f12 * 0.7F);
+            double xp = entity.owner.xo + (entity.owner.x - entity.owner.xo) * (double)partialTick + vec3.x;
+            double yp = entity.owner.yo + (entity.owner.y - entity.owner.yo) * (double)partialTick + vec3.y;
+            double zp = entity.owner.zo + (entity.owner.z - entity.owner.zo) * (double)partialTick + vec3.z;
+            if(renderDispatcher.gameSettings.thirdPersonView.value > 0)
+            {
+                float rr = ((entity.owner.yBodyRotO + (entity.owner.yBodyRot - entity.owner.yBodyRotO) * partialTick) * MathHelper.PI) / 180F;
+                double ss = MathHelper.sin(rr);
+                double cc = MathHelper.cos(rr);
+                xp = (entity.owner.xo + (entity.owner.x - entity.owner.xo) * (double)partialTick) - cc * 0.35D - ss * 0.85D;
+                yp = (entity.owner.yo + (entity.owner.y - entity.owner.yo) * (double)partialTick) - 0.45D;
+                zp = ((entity.owner.zo + (entity.owner.z - entity.owner.zo) * (double)partialTick) - ss * 0.35D) + cc * 0.85D;
+            }
+            double xh = entity.xo + (entity.x - entity.xo) * (double)partialTick;
+            double yh = entity.yo + (entity.y - entity.yo) * (double)partialTick + 0.25D;
+            double zh = entity.zo + (entity.z - entity.zo) * (double)partialTick;
+            double xa = (float)(xp - xh);
+            double ya = (float)(yp - yh);
+            double za = (float)(zp - zh);
+            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            GL11.glDisable(GL11.GL_LIGHTING);
+            tessellator.startDrawing(3);
+            tessellator.setColorOpaque_I(0);
+            for(int i = 0, steps = 16; i <= steps; i++)
+            {
+                final float aa = (float)i / (float)steps;
+                tessellator.addVertex(x + xa * (double)aa, y + ya * (double)(aa * aa + aa) * 0.5D + 0.25D, z + za * (double)aa);
+            }
+
+            tessellator.draw();
+            GL11.glEnable(GL11.GL_LIGHTING);
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/entity/GhastRenderer.java b/src/main/java/net/minecraft/client/render/entity/GhastRenderer.java
index 5eb2356eb..0b90373dc 100644
--- a/src/main/java/net/minecraft/client/render/entity/GhastRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/GhastRenderer.java
@@ -1,46 +1,37 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelGhast;
+import net.minecraft.client.render.model.GhastModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.monster.EntityGhast;
+import net.minecraft.core.entity.monster.GhastMob;
 import org.lwjgl.opengl.GL11;
 
-// Referenced classes of package net.minecraft.src:
-//            RenderLiving, ModelGhast, EntityGhast, EntityLiving
-
-public class GhastRenderer extends LivingRenderer<EntityGhast>
+public class GhastRenderer extends MobRenderer<GhastMob>
 {
 
     public GhastRenderer()
     {
-        super(new ModelGhast(), 0.5F);
-    }
-
-    protected void func_4014_a(EntityGhast entity, float f)
-    {
-        float f1 = ((float) entity.prevAttackCounter + (float)(entity.attackCounter - entity.prevAttackCounter) * f) / 20F;
-        if(f1 < 0.0F)
-        {
-            f1 = 0.0F;
-        }
-        f1 = 1.0F / (f1 * f1 * f1 * f1 * f1 * 2.0F + 1.0F);
-        float f2 = (8F + f1) / 2.0F;
-        float f3 = (8F + 1.0F / f1) / 2.0F;
-        GL11.glScalef(f3, f2, f3);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        super(new GhastModel(), 0.5F);
     }
 
     @Override
-    public void doRenderPreview(Tessellator tessellator, EntityGhast entity, double x, double y, double z, float yaw, float partialTick) {
+    public void renderPreview(Tessellator tessellator, GhastMob ghastMob, double x, double y, double z, float yaw, float partialTick) {
         GL11.glPushMatrix();
         GL11.glScalef(0.25f, 0.25f, 0.25f);
-        super.doRenderPreview(tessellator, entity, x, y, z, yaw, partialTick);
+        super.renderPreview(tessellator, ghastMob, x, y, z, yaw, partialTick);
         GL11.glPopMatrix();
     }
 
     @Override
-    protected void preRenderCallback(EntityGhast entity, float f)
-    {
-        func_4014_a(entity, f);
+    protected void setupScale(GhastMob ghastMob, float partialTick) {
+        float charge = ((float) ghastMob.attackChargeO + (float)(ghastMob.attackCharge - ghastMob.attackChargeO) * partialTick) / 20F;
+        if(charge < 0.0F)
+        {
+            charge = 0.0F;
+        }
+        charge = 1.0F / (charge * charge * charge * charge * charge * 2.0F + 1.0F);
+        float f2 = (8F + charge) / 2.0F;
+        float f3 = (8F + 1.0F / charge) / 2.0F;
+        GL11.glScalef(f3, f2, f3);
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/GiantRenderer.java b/src/main/java/net/minecraft/client/render/entity/GiantRenderer.java
index 93469c8f9..ccc2841cc 100644
--- a/src/main/java/net/minecraft/client/render/entity/GiantRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/GiantRenderer.java
@@ -1,30 +1,30 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.core.entity.monster.EntityGiant;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.core.entity.monster.GiantMob;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntityGiantZombie, ModelBase, EntityLiving
+//            RenderLiving, EntityGiantZombie, BaseModel, Mob
 
-public class GiantRenderer extends LivingRenderer<EntityGiant>
+public class GiantRenderer extends MobRenderer<GiantMob>
 {
 
-    public GiantRenderer(ModelBase modelbase, float f, float f1)
+    public GiantRenderer(BaseModel modelbase, float f, float f1)
     {
         super(modelbase, f * f1);
         scale = f1;
     }
 
-    protected void preRenderScale(EntityGiant entity, float f)
+    protected void preRenderScale(GiantMob entity, float f)
     {
         GL11.glScalef(scale, scale, scale);
     }
 
     @Override
-    protected void preRenderCallback(EntityGiant entity, float f)
+    protected void setupScale(GiantMob entity, float partialTick)
     {
-        preRenderScale(entity, f);
+        preRenderScale(entity, partialTick);
     }
 
     private float scale;
diff --git a/src/main/java/net/minecraft/client/render/entity/HumanRenderer.java b/src/main/java/net/minecraft/client/render/entity/HumanRenderer.java
new file mode 100644
index 000000000..3649fb627
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/entity/HumanRenderer.java
@@ -0,0 +1,59 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.client.render.PlayerSkinParser;
+import net.minecraft.client.render.model.BipedModel;
+import net.minecraft.client.render.model.PlayerModel;
+import net.minecraft.client.render.model.PlayerSlimModel;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.monster.HumanMob;
+import org.lwjgl.opengl.GL11;
+
+public class HumanRenderer extends MobRenderer<HumanMob>
+{
+    public HumanRenderer()
+    {
+        super(new PlayerModel(0.0F), 0.5F);
+        modelBipedMain = (BipedModel)mainModel;
+//        modelArmorChestplate = new BipedModel(1.0F);
+//        modelArmor = new BipedModel(0.5F);
+        modelThick = new PlayerModel(0.0f);
+        modelSlim = new PlayerSlimModel(0.0f);
+    }
+    @Override
+    public void render(Tessellator tessellator, HumanMob entity, double x, double y, double z, float yaw, float partialTick) {
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        mainModel = entity.slimModel ? modelSlim : modelThick;
+
+//        ItemStack itemstack = entity.getHeldItem();
+//        modelArmorChestplate.field_1278_i = modelArmor.field_1278_i = modelBipedMain.field_1278_i = itemstack != null;
+//        modelArmorChestplate.isSneak = modelArmor.isSneak = modelBipedMain.isSneak = entity.isSneaking();
+//        modelArmorChestplate.isRiding = modelArmor.isRiding = modelBipedMain.isRiding = entity.isPassenger();
+        double yRender = y - (double)entity.heightOffset;
+        if(entity.isSneaking())
+        {
+            yRender -= 0.125D;
+        }
+        super.render(tessellator, entity, x, yRender, z, yaw, partialTick);
+//        modelArmorChestplate.isSneak = modelArmor.isSneak = modelBipedMain.isSneak = false;
+//        modelArmorChestplate.field_1278_i = modelArmor.field_1278_i = modelBipedMain.field_1278_i = false;
+        GL11.glDisable(GL11.GL_BLEND);
+    }
+    @Override
+    protected void setupScale(HumanMob entity, float partialTick)
+    {
+        float scale = 0.9375F;
+        GL11.glScalef(scale, scale, scale);
+    }
+
+    @Override
+    public void loadEntityTexture(HumanMob entity)
+    {
+        bindDownloadableTexture(entity.skinUrl, entity.getEntityTexture(), PlayerSkinParser.instance);
+    }
+    private final BipedModel modelBipedMain;
+    private final PlayerModel modelThick;
+    private final PlayerModel modelSlim;
+//    private final BipedModel modelArmorChestplate;
+//    private final BipedModel modelArmor;
+}
